<script setup>
    import JetButton from '@/Jetstream/Button.vue';
    import JetDangerButton from '@/Jetstream/DangerButton.vue';
    import AppLayout from '@/Layouts/AppLayout.vue';
    import InfiniteLoading from "v3-infinite-loading";
    import "v3-infinite-loading/lib/style.css"; //required if you're not going to override default slots
    import { Link } from '@inertiajs/inertia-vue3';
    import JetConfirmationModal from '@/Jetstream/ConfirmationModal.vue';
</script>

<template>
    <AppLayout title="Job Listings">
        <template #header>

            <div class="flex items-center">



                <div class="w-full" >
                    <h2 class="font-semibold text-xl text-gray-800 leading-tight w-1/2">
                       My Job Listings
                    </h2>

                </div>

                <div    v-if="$page.props.user.company_profile !== null">
                    <JetButton @click="$inertia.get(route('job.create'))">
                        Create
                    </JetButton>



                </div>

            </div>
        </template>

        <div class="py-12">
            <div class="max-w-7xl mx-auto sm:px-6 lg:px-8"  >
                <div  class=" mb-3 flex flex-col items-center bg-white rounded-lg border shadow-md md:flex-row  hover:bg-gray-100 dark:border-gray-700 dark:bg-gray-800 dark:hover:bg-gray-700" v-for="listing in listings" :key="listing.id">
                    <img class="object-cover w-full h-96 rounded-t-lg md:h-auto md:w-48 md:rounded-none md:rounded-l-lg" v-if="listing.user.company_profile.profile_photo_url !== null" :src="listing.user.company_profile.profile_photo_url" >
                    <div class="flex flex-col justify-between p-4 leading-normal">
                      <Link :href="route('job.listing.show',{listing:listing.id})">
                        <h5 class="mb-2 text-2xl font-bold tracking-tight text-gray-900 dark:text-white">{{listing.title}}</h5>
                        <p class="mb-3 font-normal text-gray-700 dark:text-gray-400" v-html="listing.short_description"></p>
                      </Link>

                        <p class="mb-3 font-normal text-gray-700 dark:text-gray-400">

                            <JetButton class="mr-3" @click="updateListing(listing.id)">
                                Edit
                            </JetButton>
                            <JetDangerButton  @click="deleteListing(listing.id)">
                                Delete
                            </JetDangerButton >

                        </p>
                    </div>
                </div>


                <InfiniteLoading :listings="listings" @infinite="load">
                    <template #complete>
                        <span></span>
                    </template>
                </InfiniteLoading>


            </div>
        </div>

        <!-- Delete Token Confirmation Modal -->
        <JetConfirmationModal :show="listingDeleted" @close="listingDeleted = null">
            <template #title>
                Delete Listing
            </template>

            <template #content>
                Are you sure you would like to delete this Listing?
            </template>

            <template #footer>
                <JetSecondaryButton @click="listingDeleted = null">
                    Cancel
                </JetSecondaryButton>

                <JetDangerButton
                        class="ml-3"
                        @click="confirmDeletionListing"
                >
                    Delete
                </JetDangerButton>
            </template>
        </JetConfirmationModal>
    </AppLayout>


</template>

<script>
    export default {
        name: "Index",
        data(){
            return {
                listings:[],
                page:1,
                listingDeleted:null,
                deletingListing:null,
            }
        },
        methods:{
            async load($state) {

                let here = this;

                try {
                    const response = await fetch(route('job.listing.index',{page:here.page,onlyMine:1}));
                    const json = await response.json();

                    here.listings.push(...json.data);
                    $state.loaded();



                    if (_.isEmpty(json.next_page_url))
                    {
                        $state.complete();
                    }
                    else {
                        here.page++;
                    }

                } catch (error) {
                    $state.error();
                }
            },
            deleteListing(listingId)
            {
                this.deletingListing = listingId;
                this.listingDeleted = true;

            },
            updateListing(listingId)
            {

                this.$inertia.get(route('job.listing.edit',{listing:listingId}));

            },
            confirmDeletionListing()
            {
                let listingId = this.deletingListing;
                let here = this;
                axios.delete(route('job.listing.delete',{listing:listingId})).then(response => {
                    here.$inertia.get(route('job.my.listings'));
                    here.listingDeleted = null;
                    this.listingDeleted = null;

                }).catch(error => {
                    this.$page.props.jetstream.flash.banner = 'Failed to delete listing';
                    this.$page.props.jetstream.flash.bannerStyle = 'danger';
                    here.listingDeleted = null;
                    this.listingDeleted = null;
                });

            }
        }
    }
</script>

<style scoped>
    .result {
        display: flex;
        flex-direction: column;
        gap: 5px;
        font-weight: 300;
        width: 400px;
        padding: 10px;
        text-align: center;
        margin: 0 auto 10px auto;
        background: #eceef0;
        border-radius: 10px;
    }
</style>